function R = ChordInit(z, d, idx, kappa, N)
m = length(z);
for k = find((idx(:,2) == 0))'
    if idx(k,2) == 0
        idx(k,:) = idx(k,[2 1]);
        z{k} = z{k}';
        d(k,:) = -d(k,:)*z{k};
    end
end
k0 = find(idx(:,1) == 0);
% j0 = idx(k0,2);
ii0 = repmat(reshape([3*k0-2 3*k0-1 3*k0]',[],1),1,3);
jj0 = repmat([1 2 3],3*length(k0),1);
QQ = [z{k0}]*sparse(kron(sparse(diag(sqrt(kappa(k0)))),eye(3)));
QQr = reshape(-QQ,[],1); % Q = -z
l = length(k0);
QQr = QQr([reshape([9*(1:l)-8;9*(1:l)-7;9*(1:l)-6],[],1);...
reshape([9*(1:l)-5;9*(1:l)-4;9*(1:l)-3],[],1);...
reshape([9*(1:l)-2;9*(1:l)-1;9*(1:l)-0],[],1)]);
QQr = reshape(QQr,[],3);
Q = sparse(ii0,jj0,QQr,3*m,3);

% k = 1:m;
ii = (1:3*m)';
jj = idx(:,2);
jj = reshape([3*jj-2 3*jj-1 3*jj]',[],1);
HH = -reshape(repmat(sqrt(kappa),1,3)',[],1);
H = sparse(ii,jj,HH,3*m,3*N);

k1 = find(idx(:,1));
i1 = idx(k1,1);
iiz = reshape([...
    3*k1-2 3*k1-1 3*k1...
    3*k1-2 3*k1-1 3*k1...
    3*k1-2 3*k1-1 3*k1]',[],1);
jjz = reshape([...
    3*i1-2 3*i1-2 3*i1-2 ...
    3*i1-1 3*i1-1 3*i1-1 ...
    3*i1-0 3*i1-0 3*i1-0]',[],1);
HHz = [z{k1}]*sparse(kron(sparse(diag(sqrt(kappa(k1)))),eye(3)));
H = H + sparse(iiz,jjz,HHz,3*m,3*N);

M = (H'*H)\(H'*Q);
R = cell(1,N);
for i = 1:N
    [S,~,V] = svd(full(M(3*i-2:3*i,:)));
    R{i} = S*diag([1 1 det(S*V')])*V';
end
