%% Load File
g2ofilename = 'data/cubicle.g2o';

[z, d, idx, tau, kappa, N, A, anchid] = loadFile(g2ofilename);
m = length(z);

%% Chordal Initialization
R = ChordInit(z, d, idx, kappa, N);

%% Algorithm
tolerance = 1e-7;
itrMax = 100;

R = RS(z, A, idx, kappa, R, itrMax, tolerance);
P = Pos_LS(d,R,A,tau',idx);
Sm = SE(P,R,d,z,idx,kappa,tau);
fprintf('\nRS Cost: %6.3e\n',Sm);

[R, P] = PS(z, d, A, idx, tau, kappa, R, itrMax, tolerance);
Sm = SE(P,R,d,z,idx,kappa,tau);
fprintf('\nPS Cost: %6.3e\n',Sm);

%% Plot
plt(P,R,idx,anchid)
