function [z, d, idx, tau, kappa, N, A, anchid] = loadFile(g2ofilename)

disp(['Loading ''' g2ofilename '''...']);
fid = fopen(g2ofilename, 'r');
n = 0;
m = 0;
str = fgetl(fid);
while ischar(str)
    typ = strtok(str);
    if (strcmp(typ, 'VERTEX_SE3:QUAT'))
        n = n + 1;
    elseif (strcmp(typ, 'EDGE_SE3:QUAT'))
        m = m + 1;
        sae = textscan(str(14:end),'%f');
        sae = sae{1};
        sae = reshape(sae,1,[]);
        idx(m,:) = sae(1:2);
        d(m,:) = sae(3:5);
        z{m} = quat2dcm(quatnormalize(sae([9 6 7 8])));
        W = sae(10:30);
        Wi = [W(1:6);0,W(7:11);0,0,W(12:15);0,0,0,W(16:18);...
            0,0,0,0,W(19:20);0,0,0,0,0,W(21)];
        Wi = Wi + Wi' - diag(diag(Wi));
        tau(m) = 3 / trace(inv(Wi(1:3,1:3)));
        kappa(m) = 3 / (2*trace(inv(Wi(4:6,4:6))));
    end
    str = fgetl(fid);
end
edgeNum = zeros(n,1);
for i = 0:n
    edgeNum(i+1) = sum(sum(idx==i));
end
[~,anchid] = max(edgeNum);
anchid = anchid - 1;
if n<500
    anchid = 0;
end
% j = find(edgeNum == maxedge);
% anchid = j(floor(length(j)/2));
% anchid = 423;
idxa = idx;
idx(idx==anchid) = 0;
idx(idxa==0) = anchid;
N = n - 1;
tau = tau';
kappa = kappa';
%% Incidence Matrix
ii = find(idx(:,2));
jj = idx(idx(:,2)>0,2);
A = sparse(ii,jj,ones(length(ii),1),m,N);
i1 = find(idx(:,1));
jj = idx(i1,1);
A = A + sparse(i1,jj,-ones(length(i1),1),m,N);
